﻿using System;
using System.Collections.Generic;
using StateMachine;

namespace ChargingMachine
{
    public class ChargingContext : StateContext<ChargingStates>, IChargingContext
    {
        internal static Dictionary<ChargingStates, StateBase<ChargingStates>> CreateStateMap()
        {
            return new Dictionary<ChargingStates, StateBase<ChargingStates>>
            {
                {ChargingStates.Start, new StartState()},
                {ChargingStates.B1, new B1State()},
                {ChargingStates.C0B0S1, new C0B0S1State()},
                {ChargingStates.C0B1S1, new C0B1S1State()},
                {ChargingStates.C1B0S0, new C1B0S0State()},
                {ChargingStates.C1B0S1, new C1B0S1State()},
                {ChargingStates.C1B1S0, new C1B1S0State()},
                {ChargingStates.C1B1S1, new C1B1S1State()},
                {ChargingStates.S0B0C1, new S0B0C1State()},
                {ChargingStates.S0B1C1, new S0B1C1State()},
                {ChargingStates.S1B0C0, new S1B0C0State()},
                {ChargingStates.S1B0C1, new S1B0C1State()},
                {ChargingStates.S1B1C0, new S1B1C0State()},
                {ChargingStates.S1B1C1, new S1B1C1State()}
            };
        }

        public IChargingMachine ChargingMachine { get; private set; }

        public Dictionary<string, object> Flags { get; private set; }

        public ChargingContext(IChargingMachine chargingMachine)
            : base(CreateStateMap(), ChargingStates.Start, ChargingStates.End)
        {
            ChargingMachine = chargingMachine;
        }

        public void Process(TimeSpan ts, Dictionary<string, object> flags)
        {
            Flags = flags;
            Process(ts);
        }
    }
}