﻿/// Display the correct input hint  on the blob, depending on challenge touch style and where you are on the screen.
using UnityEngine;
using System.Collections;

public class InputHint: MonoBehaviour
{

    BlobController blob1_Ctrl;
    BlobController blob2_Ctrl;

    public static InputHint Instance;

    void Awake()
    {
        if(Instance == null)
            Instance = this;
    }


    public void ShowInputHint(TouchStyleDetect.PlaneTouch touchOne, TouchStyleDetect.PlaneTouch touchTwo)
    {
        
        if (TouchStyleDetect.Instance != null)
        {
            switch(TouchStyleDetect.Instance.CurrentChallenge)
            {
                case TouchStyleDetect.Challenge.Tapping:
                    {
                        blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobTap);
                    }
                 
                    break;
                case TouchStyleDetect.Challenge.HorizontalSwipe:
                    {
                        if(touchOne.BlobPos.x <= 0)
                            blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobLeft);
                        else
                            blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobRight);
                    }
                   
                    break;
                case TouchStyleDetect.Challenge.TwoFingerSwipe:
                    {
                       if(touchTwo != null)
                        { 
                            if (touchOne.BlobPos.y >= 0)
                            {
                                blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDown);
                                blob2_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDown);
                            }
                            else
                            {
                                blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobUp);
                                blob2_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDown);
                            }
                        }
                    }
                    break;
                case TouchStyleDetect.Challenge.PinchRub:
                   
                    if (touchOne.BlobPos.y > touchTwo.BlobPos.y)
                    {
                        blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobUpRight);
                        blob2_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDownLeft);
                    }
                    else
                    {
                        blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDownLeft);
                        blob2_Ctrl.SetBlobState(BlobController.BlobParameter.BlobUpRight);
                    }
                    break;
                case TouchStyleDetect.Challenge.TapAndVertical:
                   
                    break;
				case TouchStyleDetect.Challenge.DiagonalDown:
					{
						blob1_Ctrl.gameObject.transform.localPosition = new Vector3(6.0f, 3.0f, 0.0f);
						blob1_Ctrl.SetBlobState(BlobController.BlobParameter.BlobDownLeft);
					}
					break;
            }
        }
        else
        {
            Debug.Log("no stage, no hint");
        }
    }

    public void ResetInputHint()
    {
       // Reset input hint
    }

}
