﻿using UnityEngine;
using System.Collections;
using System;

public class BlobController : MonoBehaviour {
	
	public GameObject mainBlob;	
	public GameObject smallestBlob;
	public GameObject tweenblob1;
	public GameObject tweenblob2;
	public float maxDistance = 0.2f;
	public float followSpeed = 0.2f;

	private Animator _animator;
	private AnimationState currentBaseState;

	public enum BlobParameter
	{
		BlobShow,
		BlobHide,
		BlobTap,
		BlobLeft,
		BlobRight,
        BlobUp,
        BlobDown,
        BlobUpRight,
        BlobDownLeft
	}

	private BlobParameter parameter = BlobParameter.BlobHide;

	void Awake()
	{
		_animator = GetComponent<Animator>();
		transform.position = new Vector3(0,0,-20);
	}

	void Start()
	{
		SetBlobState(BlobController.BlobParameter.BlobHide);
	}

	// Update is called once per frame
	void Update () 
	{
		// Examples on triggering states
		/*
		if(Input.GetKeyDown(KeyCode.G))
			SetBlobState(BlobParameter.BlobIdle);
		if(Input.GetKeyDown(KeyCode.B))
			SetBlobState(BlobParameter.BlobLeft);
		if(Input.GetKeyDown(KeyCode.C))
			SetBlobState(BlobParameter.BlobHide);
			*/
		DoTweening();	
	}


	void DoTweening()
	{
		Vector3 tweenDistance = (smallestBlob.transform.position-mainBlob.transform.position)/3;
		tweenblob1.transform.position = mainBlob.transform.position+tweenDistance;
		tweenblob2.transform.position = mainBlob.transform.position+(tweenDistance*2);
	}


	// Set state to change animation hint. 
	public void SetBlobState(BlobController.BlobParameter blobParameter)
	{
		_animator.SetTrigger(blobParameter.ToString());
	}

	public bool IsCurrentState(BlobController.BlobParameter blobParameter)
	{
		if(_animator.GetCurrentAnimatorStateInfo(0).IsName(blobParameter.ToString()))
			return true;
		else
			return false;
	}





}
