﻿/*
Add this component to the effect/liquid camera to make sure the render target is the same aspect as the screen. We dont want distorted blobs.
*/

using UnityEngine;
using System.Collections;

public class LiquidCam : MonoBehaviour
{
    public RenderTexture CameraRenderTexture;
    private Camera _cam;
    public Material LiquidMaterial;
    public GameObject LiquidPlane;
	public static LiquidCam Instance;

    void Awake()
    {
		if(Instance == null)
			Instance = this;

        _cam = GetComponent<Camera>();
	    CameraRenderTexture = new RenderTexture(Screen.width/16, Screen.height/16, 16, RenderTextureFormat.ARGB32);
        CameraRenderTexture.wrapMode = TextureWrapMode.Clamp;
        CameraRenderTexture.useMipMap = false;
        CameraRenderTexture.filterMode = FilterMode.Bilinear;
        CameraRenderTexture.Create();

        _cam.targetTexture = CameraRenderTexture;
        LiquidMaterial.SetTexture("_MainTex", CameraRenderTexture);
		EnableBlobVisuals();
    }

	public void EnableBlobVisuals()
	{
		LiquidPlane.SetActive(true);

	}

	public void DisableBlobVisuals()
	{
		LiquidPlane.SetActive(false);
	}


}
    