﻿using UnityEngine;
using System.Collections;

public class ParticleAttraction : MonoBehaviour {

	public float Distance;
	public float Strength;
	public float Growth;
	public float MinSize;
	public float MaxSize;
	public int MaxIntegerDistance = 50;

	ParticleSystem _ps;
	ParticleSystem.Particle[] _particles;
	int _particleCount;

	Vector3 between;
	Vector3 force;
	float distanceFactor;
	float distance;
	float size;
	float squareDistance;

	void Start ()
	{
		_ps = GetComponent<ParticleSystem>();

	}
	
	// Update is called once per frame
	void LateUpdate ()
	{
		squareDistance = Distance * Distance;
		_particles = new ParticleSystem.Particle[_ps.particleCount];
		_particleCount = _ps.GetParticles(_particles);

		for(int i=0;i<_particleCount;i++)
		{
			ParticleSystem.Particle _this = _particles[i];	
			
			int endU = i+MaxIntegerDistance;
			if(endU>_particleCount) endU = _particleCount;
						
			for(int u=i+1;u<endU;u++)
			{			
				ParticleSystem.Particle _that = _particles[u];								
				if((_this.position - _that.position).sqrMagnitude > squareDistance) continue;
					
				between = (_this.position-_that.position);
				distance = between.magnitude;
				distanceFactor = 1-(distance/Distance);
				force = between.normalized * distanceFactor;


				_this.velocity -= force*Time.deltaTime*Strength;
				_this.size += distanceFactor*Growth;
				_this.size = Mathf.Clamp(_this.size,MinSize,MaxSize);

				_that.velocity += force*Time.deltaTime*Strength;
				_that.size += distanceFactor*Growth;
				_that.size = Mathf.Clamp(_that.size,MinSize,MaxSize);

				_particles[u] = _that;
				_particles[i] = _this;			
			}
		}

		_ps.SetParticles(_particles,_particleCount);

	}
}
